<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/rustc-demangle-0.1.21/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../rustc_demangle/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../rustc_demangle/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../rustc_demangle/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
<span id="472">472</span>
<span id="473">473</span>
<span id="474">474</span>
<span id="475">475</span>
<span id="476">476</span>
<span id="477">477</span>
<span id="478">478</span>
<span id="479">479</span>
<span id="480">480</span>
<span id="481">481</span>
<span id="482">482</span>
<span id="483">483</span>
<span id="484">484</span>
<span id="485">485</span>
<span id="486">486</span>
<span id="487">487</span>
<span id="488">488</span>
<span id="489">489</span>
<span id="490">490</span>
<span id="491">491</span>
<span id="492">492</span>
<span id="493">493</span>
</pre><pre class="rust"><code><span class="doccomment">//! Demangle Rust compiler symbol names.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This crate provides a `demangle` function which will return a `Demangle`</span>
<span class="doccomment">//! sentinel value that can be used to learn about the demangled version of a</span>
<span class="doccomment">//! symbol name. The demangled representation will be the same as the original</span>
<span class="doccomment">//! if it doesn&#39;t look like a mangled symbol name.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! `Demangle` can be formatted with the `Display` trait. The alternate</span>
<span class="doccomment">//! modifier (`#`) can be used to format the symbol name without the</span>
<span class="doccomment">//! trailing hash value.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Examples</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! use rustc_demangle::demangle;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! assert_eq!(demangle(&quot;_ZN4testE&quot;).to_string(), &quot;test&quot;);</span>
<span class="doccomment">//! assert_eq!(demangle(&quot;_ZN3foo3barE&quot;).to_string(), &quot;foo::bar&quot;);</span>
<span class="doccomment">//! assert_eq!(demangle(&quot;foo&quot;).to_string(), &quot;foo&quot;);</span>
<span class="doccomment">//! // With hash</span>
<span class="doccomment">//! assert_eq!(format!(&quot;{}&quot;, demangle(&quot;_ZN3foo17h05af221e174051e9E&quot;)), &quot;foo::h05af221e174051e9&quot;);</span>
<span class="doccomment">//! // Without hash</span>
<span class="doccomment">//! assert_eq!(format!(&quot;{:#}&quot;, demangle(&quot;_ZN3foo17h05af221e174051e9E&quot;)), &quot;foo&quot;);</span>
<span class="doccomment">//! ```</span>

<span class="attribute">#![<span class="ident">no_std</span>]</span>
<span class="attribute">#![<span class="ident">deny</span>(<span class="ident">missing_docs</span>)]</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">std</span>;

<span class="comment">// HACK(eddyb) helper macros for tests.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">assert_contains</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">s</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">needle</span>:<span class="ident">expr</span>) =&gt; {{
        <span class="kw">let</span> (<span class="ident">s</span>, <span class="ident">needle</span>) <span class="op">=</span> (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">s</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">needle</span>);
        <span class="macro">assert!</span>(
            <span class="ident">s</span>.<span class="ident">contains</span>(<span class="ident">needle</span>),
            <span class="string">&quot;{:?} should&#39;ve contained {:?}&quot;</span>,
            <span class="ident">s</span>,
            <span class="ident">needle</span>
        );
    }};
}
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">assert_ends_with</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">s</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">suffix</span>:<span class="ident">expr</span>) =&gt; {{
        <span class="kw">let</span> (<span class="ident">s</span>, <span class="ident">suffix</span>) <span class="op">=</span> (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">s</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">suffix</span>);
        <span class="macro">assert!</span>(
            <span class="ident">s</span>.<span class="ident">ends_with</span>(<span class="ident">suffix</span>),
            <span class="string">&quot;{:?} should&#39;ve ended in {:?}&quot;</span>,
            <span class="ident">s</span>,
            <span class="ident">suffix</span>
        );
    }};
}

<span class="kw">mod</span> <span class="ident">legacy</span>;
<span class="kw">mod</span> <span class="ident">v0</span>;

<span class="kw">use</span> <span class="ident">core::fmt</span>::{<span class="self">self</span>, <span class="ident">Write</span> <span class="kw">as</span> <span class="kw">_</span>};

<span class="doccomment">/// Representation of a demangled symbol name.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Demangle</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="ident">style</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">DemangleStyle</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="ident">original</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>,
    <span class="ident">suffix</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>,
}

<span class="kw">enum</span> <span class="ident">DemangleStyle</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="ident">Legacy</span>(<span class="ident">legacy::Demangle</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>),
    <span class="ident">V0</span>(<span class="ident">v0::Demangle</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>),
}

<span class="doccomment">/// De-mangles a Rust symbol into a more readable version</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function will take a **mangled** symbol and return a value. When printed,</span>
<span class="doccomment">/// the de-mangled version will be written. If the symbol does not look like</span>
<span class="doccomment">/// a mangled symbol, the original value will be written instead.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use rustc_demangle::demangle;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(demangle(&quot;_ZN4testE&quot;).to_string(), &quot;test&quot;);</span>
<span class="doccomment">/// assert_eq!(demangle(&quot;_ZN3foo3barE&quot;).to_string(), &quot;foo::bar&quot;);</span>
<span class="doccomment">/// assert_eq!(demangle(&quot;foo&quot;).to_string(), &quot;foo&quot;);</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">demangle</span>(<span class="kw-2">mut</span> <span class="ident">s</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">Demangle</span> {
    <span class="comment">// During ThinLTO LLVM may import and rename internal symbols, so strip out</span>
    <span class="comment">// those endings first as they&#39;re one of the last manglings applied to symbol</span>
    <span class="comment">// names.</span>
    <span class="kw">let</span> <span class="ident">llvm</span> <span class="op">=</span> <span class="string">&quot;.llvm.&quot;</span>;
    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">i</span>) <span class="op">=</span> <span class="ident">s</span>.<span class="ident">find</span>(<span class="ident">llvm</span>) {
        <span class="kw">let</span> <span class="ident">candidate</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">s</span>[<span class="ident">i</span> <span class="op">+</span> <span class="ident">llvm</span>.<span class="ident">len</span>()..];
        <span class="kw">let</span> <span class="ident">all_hex</span> <span class="op">=</span> <span class="ident">candidate</span>.<span class="ident">chars</span>().<span class="ident">all</span>(<span class="op">|</span><span class="ident">c</span><span class="op">|</span> <span class="kw">match</span> <span class="ident">c</span> {
            <span class="string">&#39;A&#39;</span>..<span class="op">=</span><span class="string">&#39;F&#39;</span> <span class="op">|</span> <span class="string">&#39;0&#39;</span>..<span class="op">=</span><span class="string">&#39;9&#39;</span> <span class="op">|</span> <span class="string">&#39;@&#39;</span> =&gt; <span class="bool-val">true</span>,
            <span class="kw">_</span> =&gt; <span class="bool-val">false</span>,
        });

        <span class="kw">if</span> <span class="ident">all_hex</span> {
            <span class="ident">s</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">s</span>[..<span class="ident">i</span>];
        }
    }

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">suffix</span> <span class="op">=</span> <span class="string">&quot;&quot;</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">style</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">legacy::demangle</span>(<span class="ident">s</span>) {
        <span class="prelude-val">Ok</span>((<span class="ident">d</span>, <span class="ident">s</span>)) =&gt; {
            <span class="ident">suffix</span> <span class="op">=</span> <span class="ident">s</span>;
            <span class="prelude-val">Some</span>(<span class="ident">DemangleStyle::Legacy</span>(<span class="ident">d</span>))
        }
        <span class="prelude-val">Err</span>(()) =&gt; <span class="kw">match</span> <span class="ident">v0::demangle</span>(<span class="ident">s</span>) {
            <span class="prelude-val">Ok</span>((<span class="ident">d</span>, <span class="ident">s</span>)) =&gt; {
                <span class="ident">suffix</span> <span class="op">=</span> <span class="ident">s</span>;
                <span class="prelude-val">Some</span>(<span class="ident">DemangleStyle::V0</span>(<span class="ident">d</span>))
            }
            <span class="comment">// FIXME(eddyb) would it make sense to treat an unknown-validity</span>
            <span class="comment">// symbol (e.g. one that errored with `RecursedTooDeep`) as</span>
            <span class="comment">// v0-mangled, and have the error show up in the demangling?</span>
            <span class="comment">// (that error already gets past this initial check, and therefore</span>
            <span class="comment">// will show up in the demangling, if hidden behind a backref)</span>
            <span class="prelude-val">Err</span>(<span class="ident">v0::ParseError::Invalid</span>) <span class="op">|</span> <span class="prelude-val">Err</span>(<span class="ident">v0::ParseError::RecursedTooDeep</span>) =&gt; <span class="prelude-val">None</span>,
        },
    };

    <span class="comment">// Output like LLVM IR adds extra period-delimited words. See if</span>
    <span class="comment">// we are in that case and save the trailing words if so.</span>
    <span class="kw">if</span> <span class="op">!</span><span class="ident">suffix</span>.<span class="ident">is_empty</span>() {
        <span class="kw">if</span> <span class="ident">suffix</span>.<span class="ident">starts_with</span>(<span class="string">&#39;.&#39;</span>) <span class="op">&amp;&amp;</span> <span class="ident">is_symbol_like</span>(<span class="ident">suffix</span>) {
            <span class="comment">// Keep the suffix.</span>
        } <span class="kw">else</span> {
            <span class="comment">// Reset the suffix and invalidate the demangling.</span>
            <span class="ident">suffix</span> <span class="op">=</span> <span class="string">&quot;&quot;</span>;
            <span class="ident">style</span> <span class="op">=</span> <span class="prelude-val">None</span>;
        }
    }

    <span class="ident">Demangle</span> {
        <span class="ident">style</span>,
        <span class="ident">original</span>: <span class="ident">s</span>,
        <span class="ident">suffix</span>,
    }
}

<span class="doccomment">/// Error returned from the `try_demangle` function below when demangling fails.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">TryDemangleError</span> {
    <span class="ident">_priv</span>: (),
}

<span class="doccomment">/// The same as `demangle`, except return an `Err` if the string does not appear</span>
<span class="doccomment">/// to be a Rust symbol, rather than &quot;demangling&quot; the given string as a no-op.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// extern crate rustc_demangle;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let not_a_rust_symbol = &quot;la la la&quot;;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // The `try_demangle` function will reject strings which are not Rust symbols.</span>
<span class="doccomment">/// assert!(rustc_demangle::try_demangle(not_a_rust_symbol).is_err());</span>
<span class="doccomment">///</span>
<span class="doccomment">/// // While `demangle` will just pass the non-symbol through as a no-op.</span>
<span class="doccomment">/// assert_eq!(rustc_demangle::demangle(not_a_rust_symbol).as_str(), not_a_rust_symbol);</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">try_demangle</span>(<span class="ident">s</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Demangle</span>, <span class="ident">TryDemangleError</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">sym</span> <span class="op">=</span> <span class="ident">demangle</span>(<span class="ident">s</span>);
    <span class="kw">if</span> <span class="ident">sym</span>.<span class="ident">style</span>.<span class="ident">is_some</span>() {
        <span class="prelude-val">Ok</span>(<span class="ident">sym</span>)
    } <span class="kw">else</span> {
        <span class="prelude-val">Err</span>(<span class="ident">TryDemangleError</span> { <span class="ident">_priv</span>: () })
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Demangle</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Returns the underlying string that&#39;s being demangled.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">as_str</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span> {
        <span class="self">self</span>.<span class="ident">original</span>
    }
}

<span class="kw">fn</span> <span class="ident">is_symbol_like</span>(<span class="ident">s</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">bool</span> {
    <span class="ident">s</span>.<span class="ident">chars</span>().<span class="ident">all</span>(<span class="op">|</span><span class="ident">c</span><span class="op">|</span> {
        <span class="comment">// Once `char::is_ascii_punctuation` and `char::is_ascii_alphanumeric`</span>
        <span class="comment">// have been stable for long enough, use those instead for clarity</span>
        <span class="ident">is_ascii_alphanumeric</span>(<span class="ident">c</span>) <span class="op">|</span><span class="op">|</span> <span class="ident">is_ascii_punctuation</span>(<span class="ident">c</span>)
    })
}

<span class="comment">// Copied from the documentation of `char::is_ascii_alphanumeric`</span>
<span class="kw">fn</span> <span class="ident">is_ascii_alphanumeric</span>(<span class="ident">c</span>: <span class="ident">char</span>) -&gt; <span class="ident">bool</span> {
    <span class="kw">match</span> <span class="ident">c</span> {
        <span class="string">&#39;\u{0041}&#39;</span>..<span class="op">=</span><span class="string">&#39;\u{005A}&#39;</span> <span class="op">|</span> <span class="string">&#39;\u{0061}&#39;</span>..<span class="op">=</span><span class="string">&#39;\u{007A}&#39;</span> <span class="op">|</span> <span class="string">&#39;\u{0030}&#39;</span>..<span class="op">=</span><span class="string">&#39;\u{0039}&#39;</span> =&gt; <span class="bool-val">true</span>,
        <span class="kw">_</span> =&gt; <span class="bool-val">false</span>,
    }
}

<span class="comment">// Copied from the documentation of `char::is_ascii_punctuation`</span>
<span class="kw">fn</span> <span class="ident">is_ascii_punctuation</span>(<span class="ident">c</span>: <span class="ident">char</span>) -&gt; <span class="ident">bool</span> {
    <span class="kw">match</span> <span class="ident">c</span> {
        <span class="string">&#39;\u{0021}&#39;</span>..<span class="op">=</span><span class="string">&#39;\u{002F}&#39;</span>
        <span class="op">|</span> <span class="string">&#39;\u{003A}&#39;</span>..<span class="op">=</span><span class="string">&#39;\u{0040}&#39;</span>
        <span class="op">|</span> <span class="string">&#39;\u{005B}&#39;</span>..<span class="op">=</span><span class="string">&#39;\u{0060}&#39;</span>
        <span class="op">|</span> <span class="string">&#39;\u{007B}&#39;</span>..<span class="op">=</span><span class="string">&#39;\u{007E}&#39;</span> =&gt; <span class="bool-val">true</span>,
        <span class="kw">_</span> =&gt; <span class="bool-val">false</span>,
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">fmt::Display</span> <span class="kw">for</span> <span class="ident">DemangleStyle</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">DemangleStyle::Legacy</span>(<span class="kw-2">ref</span> <span class="ident">d</span>) =&gt; <span class="ident">fmt::Display::fmt</span>(<span class="ident">d</span>, <span class="ident">f</span>),
            <span class="ident">DemangleStyle::V0</span>(<span class="kw-2">ref</span> <span class="ident">d</span>) =&gt; <span class="ident">fmt::Display::fmt</span>(<span class="ident">d</span>, <span class="ident">f</span>),
        }
    }
}

<span class="comment">// Maximum size of the symbol that we&#39;ll print.</span>
<span class="kw">const</span> <span class="ident">MAX_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">1_000_000</span>;

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">struct</span> <span class="ident">SizeLimitExhausted</span>;

<span class="kw">struct</span> <span class="ident">SizeLimitedFmtAdapter</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span> {
    <span class="ident">remaining</span>: <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">usize</span>, <span class="ident">SizeLimitExhausted</span><span class="op">&gt;</span>,
    <span class="ident">inner</span>: <span class="ident">F</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">fmt::Write</span><span class="op">&gt;</span> <span class="ident">fmt::Write</span> <span class="kw">for</span> <span class="ident">SizeLimitedFmtAdapter</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">write_str</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">s</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="self">self</span>.<span class="ident">remaining</span> <span class="op">=</span> <span class="self">self</span>
            .<span class="ident">remaining</span>
            .<span class="ident">and_then</span>(<span class="op">|</span><span class="ident">r</span><span class="op">|</span> <span class="ident">r</span>.<span class="ident">checked_sub</span>(<span class="ident">s</span>.<span class="ident">len</span>()).<span class="ident">ok_or</span>(<span class="ident">SizeLimitExhausted</span>));

        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">remaining</span> {
            <span class="prelude-val">Ok</span>(<span class="kw">_</span>) =&gt; <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">write_str</span>(<span class="ident">s</span>),
            <span class="prelude-val">Err</span>(<span class="ident">SizeLimitExhausted</span>) =&gt; <span class="prelude-val">Err</span>(<span class="ident">fmt::Error</span>),
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">fmt::Display</span> <span class="kw">for</span> <span class="ident">Demangle</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">style</span> {
            <span class="prelude-val">None</span> =&gt; <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="self">self</span>.<span class="ident">original</span>)<span class="question-mark">?</span>,
            <span class="prelude-val">Some</span>(<span class="kw-2">ref</span> <span class="ident">d</span>) =&gt; {
                <span class="kw">let</span> <span class="ident">alternate</span> <span class="op">=</span> <span class="ident">f</span>.<span class="ident">alternate</span>();
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">size_limited_fmt</span> <span class="op">=</span> <span class="ident">SizeLimitedFmtAdapter</span> {
                    <span class="ident">remaining</span>: <span class="prelude-val">Ok</span>(<span class="ident">MAX_SIZE</span>),
                    <span class="ident">inner</span>: <span class="kw-2">&amp;mut</span> <span class="kw-2">*</span><span class="ident">f</span>,
                };
                <span class="kw">let</span> <span class="ident">fmt_result</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">alternate</span> {
                    <span class="macro">write!</span>(<span class="ident">size_limited_fmt</span>, <span class="string">&quot;{:#}&quot;</span>, <span class="ident">d</span>)
                } <span class="kw">else</span> {
                    <span class="macro">write!</span>(<span class="ident">size_limited_fmt</span>, <span class="string">&quot;{}&quot;</span>, <span class="ident">d</span>)
                };
                <span class="kw">let</span> <span class="ident">size_limit_result</span> <span class="op">=</span> <span class="ident">size_limited_fmt</span>.<span class="ident">remaining</span>.<span class="ident">map</span>(<span class="op">|</span><span class="kw">_</span><span class="op">|</span> ());

                <span class="comment">// Translate a `fmt::Error` generated by `SizeLimitedFmtAdapter`</span>
                <span class="comment">// into an error message, instead of propagating it upwards</span>
                <span class="comment">// (which could cause panicking from inside e.g. `std::io::print`).</span>
                <span class="kw">match</span> (<span class="ident">fmt_result</span>, <span class="ident">size_limit_result</span>) {
                    (<span class="prelude-val">Err</span>(<span class="kw">_</span>), <span class="prelude-val">Err</span>(<span class="ident">SizeLimitExhausted</span>)) =&gt; <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot;{size limit reached}&quot;</span>)<span class="question-mark">?</span>,

                    <span class="kw">_</span> =&gt; {
                        <span class="ident">fmt_result</span><span class="question-mark">?</span>;
                        <span class="ident">size_limit_result</span>
                            .<span class="ident">expect</span>(<span class="string">&quot;`fmt::Error` from `SizeLimitedFmtAdapter` was discarded&quot;</span>);
                    }
                }
            }
        }
        <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="self">self</span>.<span class="ident">suffix</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">Demangle</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="ident">fmt::Display::fmt</span>(<span class="self">self</span>, <span class="ident">f</span>)
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="ident">std::prelude::v1</span>::<span class="kw-2">*</span>;

    <span class="macro">macro_rules!</span> <span class="ident">t</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span>:<span class="ident">expr</span>) =&gt; {
            <span class="macro">assert!</span>(<span class="ident">ok</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span>))
        };
    }

    <span class="macro">macro_rules!</span> <span class="ident">t_err</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>:<span class="ident">expr</span>) =&gt; {
            <span class="macro">assert!</span>(<span class="ident">ok_err</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>))
        };
    }

    <span class="macro">macro_rules!</span> <span class="ident">t_nohash</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span>:<span class="ident">expr</span>) =&gt; {{
            <span class="macro">assert_eq!</span>(<span class="macro">format!</span>(<span class="string">&quot;{:#}&quot;</span>, <span class="ident"><span class="kw">super</span>::demangle</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>)), <span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span>);
        }};
    }

    <span class="kw">fn</span> <span class="ident">ok</span>(<span class="ident">sym</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>, <span class="ident">expected</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">bool</span> {
        <span class="kw">match</span> <span class="ident"><span class="kw">super</span>::try_demangle</span>(<span class="ident">sym</span>) {
            <span class="prelude-val">Ok</span>(<span class="ident">s</span>) =&gt; {
                <span class="kw">if</span> <span class="ident">s</span>.<span class="ident">to_string</span>() <span class="op">==</span> <span class="ident">expected</span> {
                    <span class="bool-val">true</span>
                } <span class="kw">else</span> {
                    <span class="macro">println!</span>(<span class="string">&quot;\n{}\n!=\n{}\n&quot;</span>, <span class="ident">s</span>, <span class="ident">expected</span>);
                    <span class="bool-val">false</span>
                }
            }
            <span class="prelude-val">Err</span>(<span class="kw">_</span>) =&gt; {
                <span class="macro">println!</span>(<span class="string">&quot;error demangling&quot;</span>);
                <span class="bool-val">false</span>
            }
        }
    }

    <span class="kw">fn</span> <span class="ident">ok_err</span>(<span class="ident">sym</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">bool</span> {
        <span class="kw">match</span> <span class="ident"><span class="kw">super</span>::try_demangle</span>(<span class="ident">sym</span>) {
            <span class="prelude-val">Ok</span>(<span class="kw">_</span>) =&gt; {
                <span class="macro">println!</span>(<span class="string">&quot;succeeded in demangling&quot;</span>);
                <span class="bool-val">false</span>
            }
            <span class="prelude-val">Err</span>(<span class="kw">_</span>) =&gt; <span class="ident"><span class="kw">super</span>::demangle</span>(<span class="ident">sym</span>).<span class="ident">to_string</span>() <span class="op">==</span> <span class="ident">sym</span>,
        }
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle</span>() {
        <span class="macro">t_err!</span>(<span class="string">&quot;test&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;_ZN4testE&quot;</span>, <span class="string">&quot;test&quot;</span>);
        <span class="macro">t_err!</span>(<span class="string">&quot;_ZN4test&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;_ZN4test1a2bcE&quot;</span>, <span class="string">&quot;test::a::bc&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle_dollars</span>() {
        <span class="macro">t!</span>(<span class="string">&quot;_ZN4$RP$E&quot;</span>, <span class="string">&quot;)&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;_ZN8$RF$testE&quot;</span>, <span class="string">&quot;&amp;test&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;_ZN8$BP$test4foobE&quot;</span>, <span class="string">&quot;*test::foob&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;_ZN9$u20$test4foobE&quot;</span>, <span class="string">&quot; test::foob&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;_ZN35Bar$LT$$u5b$u32$u3b$$u20$4$u5d$$GT$E&quot;</span>, <span class="string">&quot;Bar&lt;[u32; 4]&gt;&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle_many_dollars</span>() {
        <span class="macro">t!</span>(<span class="string">&quot;_ZN13test$u20$test4foobE&quot;</span>, <span class="string">&quot;test test::foob&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;_ZN12test$BP$test4foobE&quot;</span>, <span class="string">&quot;test*test::foob&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle_osx</span>() {
        <span class="macro">t!</span>(
            <span class="string">&quot;__ZN5alloc9allocator6Layout9for_value17h02a996811f781011E&quot;</span>,
            <span class="string">&quot;alloc::allocator::Layout::for_value::h02a996811f781011&quot;</span>
        );
        <span class="macro">t!</span>(<span class="string">&quot;__ZN38_$LT$core..option..Option$LT$T$GT$$GT$6unwrap18_MSG_FILE_LINE_COL17haf7cb8d5824ee659E&quot;</span>, <span class="string">&quot;&lt;core::option::Option&lt;T&gt;&gt;::unwrap::_MSG_FILE_LINE_COL::haf7cb8d5824ee659&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;__ZN4core5slice89_$LT$impl$u20$core..iter..traits..IntoIterator$u20$for$u20$$RF$$u27$a$u20$$u5b$T$u5d$$GT$9into_iter17h450e234d27262170E&quot;</span>, <span class="string">&quot;core::slice::&lt;impl core::iter::traits::IntoIterator for &amp;&#39;a [T]&gt;::into_iter::h450e234d27262170&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle_windows</span>() {
        <span class="macro">t!</span>(<span class="string">&quot;ZN4testE&quot;</span>, <span class="string">&quot;test&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;ZN13test$u20$test4foobE&quot;</span>, <span class="string">&quot;test test::foob&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;ZN12test$RF$test4foobE&quot;</span>, <span class="string">&quot;test&amp;test::foob&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle_elements_beginning_with_underscore</span>() {
        <span class="macro">t!</span>(<span class="string">&quot;_ZN13_$LT$test$GT$E&quot;</span>, <span class="string">&quot;&lt;test&gt;&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;_ZN28_$u7b$$u7b$closure$u7d$$u7d$E&quot;</span>, <span class="string">&quot;{{closure}}&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;_ZN15__STATIC_FMTSTRE&quot;</span>, <span class="string">&quot;__STATIC_FMTSTR&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle_trait_impls</span>() {
        <span class="macro">t!</span>(
            <span class="string">&quot;_ZN71_$LT$Test$u20$$u2b$$u20$$u27$static$u20$as$u20$foo..Bar$LT$Test$GT$$GT$3barE&quot;</span>,
            <span class="string">&quot;&lt;Test + &#39;static as foo::Bar&lt;Test&gt;&gt;::bar&quot;</span>
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle_without_hash</span>() {
        <span class="kw">let</span> <span class="ident">s</span> <span class="op">=</span> <span class="string">&quot;_ZN3foo17h05af221e174051e9E&quot;</span>;
        <span class="macro">t!</span>(<span class="ident">s</span>, <span class="string">&quot;foo::h05af221e174051e9&quot;</span>);
        <span class="macro">t_nohash!</span>(<span class="ident">s</span>, <span class="string">&quot;foo&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle_without_hash_edgecases</span>() {
        <span class="comment">// One element, no hash.</span>
        <span class="macro">t_nohash!</span>(<span class="string">&quot;_ZN3fooE&quot;</span>, <span class="string">&quot;foo&quot;</span>);
        <span class="comment">// Two elements, no hash.</span>
        <span class="macro">t_nohash!</span>(<span class="string">&quot;_ZN3foo3barE&quot;</span>, <span class="string">&quot;foo::bar&quot;</span>);
        <span class="comment">// Longer-than-normal hash.</span>
        <span class="macro">t_nohash!</span>(<span class="string">&quot;_ZN3foo20h05af221e174051e9abcE&quot;</span>, <span class="string">&quot;foo&quot;</span>);
        <span class="comment">// Shorter-than-normal hash.</span>
        <span class="macro">t_nohash!</span>(<span class="string">&quot;_ZN3foo5h05afE&quot;</span>, <span class="string">&quot;foo&quot;</span>);
        <span class="comment">// Valid hash, but not at the end.</span>
        <span class="macro">t_nohash!</span>(<span class="string">&quot;_ZN17h05af221e174051e93fooE&quot;</span>, <span class="string">&quot;h05af221e174051e9::foo&quot;</span>);
        <span class="comment">// Not a valid hash, missing the &#39;h&#39;.</span>
        <span class="macro">t_nohash!</span>(<span class="string">&quot;_ZN3foo16ffaf221e174051e9E&quot;</span>, <span class="string">&quot;foo::ffaf221e174051e9&quot;</span>);
        <span class="comment">// Not a valid hash, has a non-hex-digit.</span>
        <span class="macro">t_nohash!</span>(<span class="string">&quot;_ZN3foo17hg5af221e174051e9E&quot;</span>, <span class="string">&quot;foo::hg5af221e174051e9&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle_thinlto</span>() {
        <span class="comment">// One element, no hash.</span>
        <span class="macro">t!</span>(<span class="string">&quot;_ZN3fooE.llvm.9D1C9369&quot;</span>, <span class="string">&quot;foo&quot;</span>);
        <span class="macro">t!</span>(<span class="string">&quot;_ZN3fooE.llvm.9D1C9369@@16&quot;</span>, <span class="string">&quot;foo&quot;</span>);
        <span class="macro">t_nohash!</span>(
            <span class="string">&quot;_ZN9backtrace3foo17hbb467fcdaea5d79bE.llvm.A5310EB9&quot;</span>,
            <span class="string">&quot;backtrace::foo&quot;</span>
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle_llvm_ir_branch_labels</span>() {
        <span class="macro">t!</span>(<span class="string">&quot;_ZN4core5slice77_$LT$impl$u20$core..ops..index..IndexMut$LT$I$GT$$u20$for$u20$$u5b$T$u5d$$GT$9index_mut17haf9727c2edfbc47bE.exit.i.i&quot;</span>, <span class="string">&quot;core::slice::&lt;impl core::ops::index::IndexMut&lt;I&gt; for [T]&gt;::index_mut::haf9727c2edfbc47b.exit.i.i&quot;</span>);
        <span class="macro">t_nohash!</span>(<span class="string">&quot;_ZN4core5slice77_$LT$impl$u20$core..ops..index..IndexMut$LT$I$GT$$u20$for$u20$$u5b$T$u5d$$GT$9index_mut17haf9727c2edfbc47bE.exit.i.i&quot;</span>, <span class="string">&quot;core::slice::&lt;impl core::ops::index::IndexMut&lt;I&gt; for [T]&gt;::index_mut.exit.i.i&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">demangle_ignores_suffix_that_doesnt_look_like_a_symbol</span>() {
        <span class="macro">t_err!</span>(<span class="string">&quot;_ZN3fooE.llvm moocow&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">dont_panic</span>() {
        <span class="ident"><span class="kw">super</span>::demangle</span>(<span class="string">&quot;_ZN2222222222222222222222EE&quot;</span>).<span class="ident">to_string</span>();
        <span class="ident"><span class="kw">super</span>::demangle</span>(<span class="string">&quot;_ZN5*70527e27.ll34csaғE&quot;</span>).<span class="ident">to_string</span>();
        <span class="ident"><span class="kw">super</span>::demangle</span>(<span class="string">&quot;_ZN5*70527a54.ll34_$b.1E&quot;</span>).<span class="ident">to_string</span>();
        <span class="ident"><span class="kw">super</span>::demangle</span>(
            <span class="string">&quot;\
             _ZN5~saäb4e\n\
             2734cOsbE\n\
             5usage20h)3\0\0\0\0\0\0\07e2734cOsbE\
             &quot;</span>,
        )
        .<span class="ident">to_string</span>();
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">invalid_no_chop</span>() {
        <span class="macro">t_err!</span>(<span class="string">&quot;_ZNfooE&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">handle_assoc_types</span>() {
        <span class="macro">t!</span>(<span class="string">&quot;_ZN151_$LT$alloc..boxed..Box$LT$alloc..boxed..FnBox$LT$A$C$$u20$Output$u3d$R$GT$$u20$$u2b$$u20$$u27$a$GT$$u20$as$u20$core..ops..function..FnOnce$LT$A$GT$$GT$9call_once17h69e8f44b3723e1caE&quot;</span>, <span class="string">&quot;&lt;alloc::boxed::Box&lt;alloc::boxed::FnBox&lt;A, Output=R&gt; + &#39;a&gt; as core::ops::function::FnOnce&lt;A&gt;&gt;::call_once::h69e8f44b3723e1ca&quot;</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">handle_bang</span>() {
        <span class="macro">t!</span>(
            <span class="string">&quot;_ZN88_$LT$core..result..Result$LT$$u21$$C$$u20$E$GT$$u20$as$u20$std..process..Termination$GT$6report17hfc41d0da4a40b3e8E&quot;</span>,
            <span class="string">&quot;&lt;core::result::Result&lt;!, E&gt; as std::process::Termination&gt;::report::hfc41d0da4a40b3e8&quot;</span>
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">limit_recursion</span>() {
        <span class="macro">assert_contains!</span>(
            <span class="ident"><span class="kw">super</span>::demangle</span>(<span class="string">&quot;_RNvB_1a&quot;</span>).<span class="ident">to_string</span>(),
            <span class="string">&quot;{recursion limit reached}&quot;</span>
        );
        <span class="macro">assert_contains!</span>(
            <span class="ident"><span class="kw">super</span>::demangle</span>(<span class="string">&quot;_RMC0RB2_&quot;</span>).<span class="ident">to_string</span>(),
            <span class="string">&quot;{recursion limit reached}&quot;</span>
        );
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">limit_output</span>() {
        <span class="macro">assert_ends_with!</span>(
            <span class="ident"><span class="kw">super</span>::demangle</span>(<span class="string">&quot;RYFG_FGyyEvRYFF_EvRYFFEvERLB_B_B_ERLRjB_B_B_&quot;</span>).<span class="ident">to_string</span>(),
            <span class="string">&quot;{size limit reached}&quot;</span>
        );
        <span class="comment">// NOTE(eddyb) somewhat reduced version of the above, effectively</span>
        <span class="comment">// `&lt;for&lt;...&gt; fn()&gt;` with a larger number of lifetimes in `...`.</span>
        <span class="macro">assert_ends_with!</span>(
            <span class="ident"><span class="kw">super</span>::demangle</span>(<span class="string">&quot;_RMC0FGZZZ_Eu&quot;</span>).<span class="ident">to_string</span>(),
            <span class="string">&quot;{size limit reached}&quot;</span>
        );
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="rustc_demangle" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>